/*
 *  material.h
 *  RayTracer
 *
 *  Modified by Rick Skarbez for COMP 575 - Fall 2007
 *  Originally created by Eric Bennett on 8/8/06.
 */

#ifndef MATERIAL_H
#define MATERIAL_H

#define REFRACT_AIR .997

#include <iostream>
#include "color.h"
#include "vector3D.h"
#include "light.h"
#include "ray3D.h"
#include "object.h"

#define TINY 0.0000001

class ray3D;
class object;

class material
{
public:
	double r, g, b;
	double mixAmbient, mixDiffuse, mixSpecular;
	double phongCoeff, mixReflection;
	double mixRefraction, indexRefraction;
	
	material *nextMaterial;
	color shade(ray3D &ray,  int recLevel, int maxRec, color &backColor, double currRIndex, object *objects, light *lights);
	
	material(double newr, double newg, double newb,
			 double newMixAmbient, double newMixDiffuse, double newMixSpecular,
			 double newPhongCoeff, double newMixReflection, double newMixRefraction, double newRefractionIndex);
};

#endif