/*
 *  object.h
 *  RayTracer
 *
 *  Modified by Rick Skarbez for COMP 575 - Fall 2007
 *  Originally created by Eric Bennett on 8/8/06.
 */

#ifndef OBJECT_H
#define OBJECT_H

#include "vector3D.h"
#include "ray3D.h"
#include "color.h"
#include "material.h"
#include "light.h"

// Eliminates include looping
class ray3D;
class material;

class object
{
public:
	virtual void intersect(ray3D &r);
	virtual color shade(ray3D &r, int recLevel, int maxRec, color &backColor, double currRIndex, object *objects, light *lights);
	matrix44 forwardMatrix;
	matrix44 backwardMatrix;
	material *materialPtr;
	object *nextObject;
};

class Sphere : object
{
public:
	Sphere();
	void intersect(ray3D &r);
};

class Plane : object
{
public:
	Plane();
	void intersect(ray3D &r);
	virtual color shade(ray3D &r, int recLevel, int maxRec, color &backColor, double currRIndex, object *objects, light *lights);
};


#endif